//
// UsersAPI.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Foundation
import Alamofire


open class UsersAPI {
    /**
     Create new user

     - parameter body: (body)  
     - parameter organizationId: (query)  (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func createUser(body: UserCreate, organizationId: Int? = nil, completion: @escaping ((_ data: UserGet?,_ error: Error?) -> Void)) {
        createUserWithRequestBuilder(body: body, organizationId: organizationId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Create new user
     - POST /api/v1/users

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "avatar_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
  "is_active" : true,
  "is_superuser" : true,
  "avatar_url" : "http://example.com/aeiou",
  "role_id" : 5,
  "organization_id" : 6,
  "last_name" : "last_name",
  "groups" : [ {
    "name" : "name",
    "id" : 1
  }, {
    "name" : "name",
    "id" : 1
  } ],
  "id" : 0,
  "organization_name" : "organization_name",
  "first_name" : "first_name",
  "email" : ""
}}]
     - parameter body: (body)  
     - parameter organizationId: (query)  (optional)

     - returns: RequestBuilder<UserGet> 
     */
    open class func createUserWithRequestBuilder(body: UserCreate, organizationId: Int? = nil) -> RequestBuilder<UserGet> {
        let path = "/api/v1/users"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "organization_id": organizationId?.encodeToJSON()
        ])


        let requestBuilder: RequestBuilder<UserGet>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
    /**
     Delete user with provided ID

     - parameter userId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func deleteUser(userId: Int, completion: @escaping ((_ data: APIResponseStatusOK?,_ error: Error?) -> Void)) {
        deleteUserWithRequestBuilder(userId: userId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Delete user with provided ID
     - DELETE /api/v1/users/{user_id}
     - 

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "status" : "ok"
}}]
     - parameter userId: (path)  

     - returns: RequestBuilder<APIResponseStatusOK> 
     */
    open class func deleteUserWithRequestBuilder(userId: Int) -> RequestBuilder<APIResponseStatusOK> {
        var path = "/api/v1/users/{user_id}"
        let userIdPreEscape = "\(userId)"
        let userIdPostEscape = userIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{user_id}", with: userIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<APIResponseStatusOK>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "DELETE", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Get currently authenticated user

     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getCurrentUser(completion: @escaping ((_ data: UserGet?,_ error: Error?) -> Void)) {
        getCurrentUserWithRequestBuilder().execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Get currently authenticated user
     - GET /api/v1/users/me
     - 

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "avatar_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
  "is_active" : true,
  "is_superuser" : true,
  "avatar_url" : "http://example.com/aeiou",
  "role_id" : 5,
  "organization_id" : 6,
  "last_name" : "last_name",
  "groups" : [ {
    "name" : "name",
    "id" : 1
  }, {
    "name" : "name",
    "id" : 1
  } ],
  "id" : 0,
  "organization_name" : "organization_name",
  "first_name" : "first_name",
  "email" : ""
}}]

     - returns: RequestBuilder<UserGet> 
     */
    open class func getCurrentUserWithRequestBuilder() -> RequestBuilder<UserGet> {
        let path = "/api/v1/users/me"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<UserGet>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Get user with provided ID

     - parameter userId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getUser(userId: Int, completion: @escaping ((_ data: UserGet?,_ error: Error?) -> Void)) {
        getUserWithRequestBuilder(userId: userId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Get user with provided ID
     - GET /api/v1/users/{user_id}
     - 

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "avatar_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
  "is_active" : true,
  "is_superuser" : true,
  "avatar_url" : "http://example.com/aeiou",
  "role_id" : 5,
  "organization_id" : 6,
  "last_name" : "last_name",
  "groups" : [ {
    "name" : "name",
    "id" : 1
  }, {
    "name" : "name",
    "id" : 1
  } ],
  "id" : 0,
  "organization_name" : "organization_name",
  "first_name" : "first_name",
  "email" : ""
}}]
     - parameter userId: (path)  

     - returns: RequestBuilder<UserGet> 
     */
    open class func getUserWithRequestBuilder(userId: Int) -> RequestBuilder<UserGet> {
        var path = "/api/v1/users/{user_id}"
        let userIdPreEscape = "\(userId)"
        let userIdPostEscape = userIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{user_id}", with: userIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<UserGet>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Get list of users

     - parameter withoutGroups: (query)  (optional, default to false)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getUsers(withoutGroups: Bool? = nil, completion: @escaping ((_ data: UserList?,_ error: Error?) -> Void)) {
        getUsersWithRequestBuilder(withoutGroups: withoutGroups).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Get list of users
     - GET /api/v1/users
     - 

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "users" : [ {
    "avatar_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "is_active" : true,
    "is_superuser" : true,
    "avatar_url" : "http://example.com/aeiou",
    "role_id" : 5,
    "organization_id" : 6,
    "last_name" : "last_name",
    "groups" : [ {
      "name" : "name",
      "id" : 1
    }, {
      "name" : "name",
      "id" : 1
    } ],
    "id" : 0,
    "organization_name" : "organization_name",
    "first_name" : "first_name",
    "email" : ""
  }, {
    "avatar_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "is_active" : true,
    "is_superuser" : true,
    "avatar_url" : "http://example.com/aeiou",
    "role_id" : 5,
    "organization_id" : 6,
    "last_name" : "last_name",
    "groups" : [ {
      "name" : "name",
      "id" : 1
    }, {
      "name" : "name",
      "id" : 1
    } ],
    "id" : 0,
    "organization_name" : "organization_name",
    "first_name" : "first_name",
    "email" : ""
  } ]
}}]
     - parameter withoutGroups: (query)  (optional, default to false)

     - returns: RequestBuilder<UserList> 
     */
    open class func getUsersWithRequestBuilder(withoutGroups: Bool? = nil) -> RequestBuilder<UserList> {
        let path = "/api/v1/users"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "without_groups": withoutGroups
        ])


        let requestBuilder: RequestBuilder<UserList>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Search users by provided query

     - parameter body: (body)  
     - parameter withoutGroups: (query)  (optional, default to false)
     - parameter organizationId: (query)  (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func searchUsers(body: UserSearchBody, withoutGroups: Bool? = nil, organizationId: Int? = nil, completion: @escaping ((_ data: UserList?,_ error: Error?) -> Void)) {
        searchUsersWithRequestBuilder(body: body, withoutGroups: withoutGroups, organizationId: organizationId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Search users by provided query
     - POST /api/v1/users/search

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "users" : [ {
    "avatar_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "is_active" : true,
    "is_superuser" : true,
    "avatar_url" : "http://example.com/aeiou",
    "role_id" : 5,
    "organization_id" : 6,
    "last_name" : "last_name",
    "groups" : [ {
      "name" : "name",
      "id" : 1
    }, {
      "name" : "name",
      "id" : 1
    } ],
    "id" : 0,
    "organization_name" : "organization_name",
    "first_name" : "first_name",
    "email" : ""
  }, {
    "avatar_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "is_active" : true,
    "is_superuser" : true,
    "avatar_url" : "http://example.com/aeiou",
    "role_id" : 5,
    "organization_id" : 6,
    "last_name" : "last_name",
    "groups" : [ {
      "name" : "name",
      "id" : 1
    }, {
      "name" : "name",
      "id" : 1
    } ],
    "id" : 0,
    "organization_name" : "organization_name",
    "first_name" : "first_name",
    "email" : ""
  } ]
}}]
     - parameter body: (body)  
     - parameter withoutGroups: (query)  (optional, default to false)
     - parameter organizationId: (query)  (optional)

     - returns: RequestBuilder<UserList> 
     */
    open class func searchUsersWithRequestBuilder(body: UserSearchBody, withoutGroups: Bool? = nil, organizationId: Int? = nil) -> RequestBuilder<UserList> {
        let path = "/api/v1/users/search"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "without_groups": withoutGroups, 
                        "organization_id": organizationId?.encodeToJSON()
        ])


        let requestBuilder: RequestBuilder<UserList>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
    /**
     Update currently authenticated user

     - parameter body: (body)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func updateCurrentUser(body: UserCurrentUpdate, completion: @escaping ((_ data: UserGet?,_ error: Error?) -> Void)) {
        updateCurrentUserWithRequestBuilder(body: body).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Update currently authenticated user
     - PUT /api/v1/users/me
     - 

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "avatar_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
  "is_active" : true,
  "is_superuser" : true,
  "avatar_url" : "http://example.com/aeiou",
  "role_id" : 5,
  "organization_id" : 6,
  "last_name" : "last_name",
  "groups" : [ {
    "name" : "name",
    "id" : 1
  }, {
    "name" : "name",
    "id" : 1
  } ],
  "id" : 0,
  "organization_name" : "organization_name",
  "first_name" : "first_name",
  "email" : ""
}}]
     - parameter body: (body)  

     - returns: RequestBuilder<UserGet> 
     */
    open class func updateCurrentUserWithRequestBuilder(body: UserCurrentUpdate) -> RequestBuilder<UserGet> {
        let path = "/api/v1/users/me"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<UserGet>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "PUT", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
    /**
     Update currently authenticated user email

     - parameter body: (body)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func updateCurrentUserEmail(body: UserCurrentEmailUpdateBody, completion: @escaping ((_ data: UserGet?,_ error: Error?) -> Void)) {
        updateCurrentUserEmailWithRequestBuilder(body: body).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Update currently authenticated user email
     - PUT /api/v1/users/me/email
     - 

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "avatar_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
  "is_active" : true,
  "is_superuser" : true,
  "avatar_url" : "http://example.com/aeiou",
  "role_id" : 5,
  "organization_id" : 6,
  "last_name" : "last_name",
  "groups" : [ {
    "name" : "name",
    "id" : 1
  }, {
    "name" : "name",
    "id" : 1
  } ],
  "id" : 0,
  "organization_name" : "organization_name",
  "first_name" : "first_name",
  "email" : ""
}}]
     - parameter body: (body)  

     - returns: RequestBuilder<UserGet> 
     */
    open class func updateCurrentUserEmailWithRequestBuilder(body: UserCurrentEmailUpdateBody) -> RequestBuilder<UserGet> {
        let path = "/api/v1/users/me/email"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<UserGet>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "PUT", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
    /**
     Update currently authenticated user password

     - parameter body: (body)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func updateCurrentUserPassword(body: UserCurrentPasswordUpdateBody, completion: @escaping ((_ data: UserGet?,_ error: Error?) -> Void)) {
        updateCurrentUserPasswordWithRequestBuilder(body: body).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Update currently authenticated user password
     - PUT /api/v1/users/me/password
     - 

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "avatar_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
  "is_active" : true,
  "is_superuser" : true,
  "avatar_url" : "http://example.com/aeiou",
  "role_id" : 5,
  "organization_id" : 6,
  "last_name" : "last_name",
  "groups" : [ {
    "name" : "name",
    "id" : 1
  }, {
    "name" : "name",
    "id" : 1
  } ],
  "id" : 0,
  "organization_name" : "organization_name",
  "first_name" : "first_name",
  "email" : ""
}}]
     - parameter body: (body)  

     - returns: RequestBuilder<UserGet> 
     */
    open class func updateCurrentUserPasswordWithRequestBuilder(body: UserCurrentPasswordUpdateBody) -> RequestBuilder<UserGet> {
        let path = "/api/v1/users/me/password"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<UserGet>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "PUT", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
    /**
     Update user with provided ID

     - parameter body: (body)  
     - parameter userId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func updateUser(body: UserUpdate, userId: Int, completion: @escaping ((_ data: UserGet?,_ error: Error?) -> Void)) {
        updateUserWithRequestBuilder(body: body, userId: userId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Update user with provided ID
     - PUT /api/v1/users/{user_id}
     - 

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "avatar_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
  "is_active" : true,
  "is_superuser" : true,
  "avatar_url" : "http://example.com/aeiou",
  "role_id" : 5,
  "organization_id" : 6,
  "last_name" : "last_name",
  "groups" : [ {
    "name" : "name",
    "id" : 1
  }, {
    "name" : "name",
    "id" : 1
  } ],
  "id" : 0,
  "organization_name" : "organization_name",
  "first_name" : "first_name",
  "email" : ""
}}]
     - parameter body: (body)  
     - parameter userId: (path)  

     - returns: RequestBuilder<UserGet> 
     */
    open class func updateUserWithRequestBuilder(body: UserUpdate, userId: Int) -> RequestBuilder<UserGet> {
        var path = "/api/v1/users/{user_id}"
        let userIdPreEscape = "\(userId)"
        let userIdPostEscape = userIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{user_id}", with: userIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<UserGet>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "PUT", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
}
